use std::fs;

use pest::Parser;
use pest_derive::Parser;

#[derive(Parser)]
#[grammar = "rpy.pest"]
struct RpyParser;

pub fn parse(file_path: &str) {
    let unparsed_file = fs::read_to_string(file_path).expect("cannot find file");
    let file = RpyParser::parse(Rule::file, &unparsed_file)
        .expect("unsuccessful parse") // unwrap the parse result
        .next().unwrap(); // get and unwrap the `file` rule; never fails
    for line in file.into_inner() {
        match line.as_rule() {
            Rule::line => {
                println!("Line:");
                for token in line.into_inner() {
                    match token.as_rule() {
                        Rule::token => {
                            let token =  token.into_inner().next().unwrap();
                            match token.as_rule() {
                                Rule::string => println!("string: {}", token.as_str()),
                                Rule::keyword => println!("keyword: {}", token.as_str()),
                                _ => unreachable!(),
                            };
                        },
                        _ => unreachable!(),
                    }
                }
                println!()
            },
            Rule::EOI => (),
            _ => unreachable!(),
        }
    }
}
